
QGIS Application - Bug report #12010

Can edit Z geom but fail to create it
Status: Closed

Priority: Normal

Assignee:

Category: Digitising

Affected QGIS version:2.6.1 Regression?: No

Operating System: Windows Easy fix?: No

Pull Request or Patch supplied:No Resolution: end of life

Crashes QGIS or corrupts data:No Copied to github as #: 20213

Description

Version of qgis is 2.6.1 on windows 64.

The bug is pretty simple.

Creating a 3D table in postgis, it is possible to edit the 3D geom, but we get an errro when trying to create a new geometry.

----------------------

CREATE TABLE 

test_z_qgis AS  

SELECT 1::int AS gid, ST_GeomFRomText('LinestringZ(0 0 0 , 1 1 1, 2 2 2 )',4326)::geometry(linestringZ,4326) AS geom; 

-----------------------------

Then loading this layer in qgis.

It is possible to edit the geometry 

(inserted vertex have 0 Z by the way, it could be interpolated lineary at least).

But when trying to create a new geometry : ERROR : "Column has Z dimension but geometry does not"

Cheers,

Rémi-C

History

#1 - 2015-10-04 12:29 AM - Tudor Bărăscu

I also encountered this problem in the latest master (2.11).

As QGIS editing tools don't created (currently) 3D features, one solution would be to have triggers that take the 2d line created by QGIS and transform it

into a 3d line by reading another attribute column(s) that have z data values.

However, the default way of creating geometry columns in a Postgis database is using type modifier since postgis 2.0.

This gets in the way of the triggers as the geometry constraints are checked before any trigger is run.

But if the geometry column is created using the old check constraints behavior, see http://postgis.net/docs/AddGeometryColumn.html, like this..

SELECT AddGeometryColumn ('schema_name','table_name','geometry_column',SRID,'LINESTRING',3, false);

and if you have a trigger that forces the geometry in 3d ( NEW.geometry := ST_Force3D(NEW.geometry);

 then it will work.

All the best

#2 - 2015-10-04 12:30 AM - Tudor Bărăscu

- Target version set to Future Release - Nice to have
http://postgis.net/docs/AddGeometryColumn.html


#3 - 2015-10-04 02:37 AM - Jürgen Fischer

- Assignee deleted (Jürgen Fischer)

- Category changed from Data Provider/PostGIS to Vectors

#4 - 2015-10-04 02:37 AM - Jürgen Fischer

- Category changed from Vectors to Digitising

#5 - 2016-01-24 03:53 AM - Tudor Bărăscu

See https://github.com/qgis/QGIS/pull/2703

#6 - 2017-05-01 01:07 AM - Giovanni Manghi

- Regression? set to No

- Easy fix? set to No

#7 - 2019-03-09 03:12 PM - Giovanni Manghi

- Resolution set to end of life

- Status changed from Open to Closed

End of life notice: QGIS 2.18 LTR

Source:

http://blog.qgis.org/2019/03/09/end-of-life-notice-qgis-2-18-ltr/
